<?php

namespace App\Http\Controllers;

use App\Models\Course;
use App\Models\Setting;
use App\Models\Student;
use App\Models\Teacher;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;

class AdminController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        return view('admin.dashboard');
    }

    public function indexSettings()
    {
        $setting=Setting::select('*')->first();

        return view('admin.settings',['settings'=>$setting]);
    }
    public function indexTeachers()
    {
        $teachers=Teacher::select('*')->get();
        // dd(teachers)

        return view('admin.teacherManagement',['teachers'=>$teachers]);
    }
    public function indexStudent()
    {
        $students=Student::select('*')->get();
        return view('admin.studentManagement',['students'=>$students]);
    }

    public function indexCourse()
    {
        $courses=Course::with('teachers')->get();
        $teachers = Teacher::all(); // جلب جميع المدرسين

        return view('admin.coursesManagement',['courses'=>$courses,'teachers'=>$teachers]);
    }


    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(string $id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request)
    {
        $validatedData = $request->validate([
            'website_name' => 'required|string|max:255',
            'website_description' => 'required|string|max:255',
            'facebook' => 'nullable|url',
            'twitter' => 'nullable|url',
            'youtube' => 'nullable|url',
            'instagram' => 'nullable|url',
            'logo' => 'nullable|image|mimes:jpg,png,gif|max:2048',
            'icon' => 'nullable|image|mimes:jpg,png,gif|max:1024',
            'store_price' => 'nullable|numeric',
            'currency' => 'nullable|string|max:10',
            'aboutUsContent' => 'nullable|string', // Add validation for aboutUsContent
                        'terms_and_conditions' => 'nullable|string',

            'aboutUsImage1' => 'nullable|image|mimes:jpg,png,gif|max:2048',
            'aboutUsImage2' => 'nullable|image|mimes:jpg,png,gif|max:2048',
            'aboutUsImage3' => 'nullable|image|mimes:jpg,png,gif|max:2048',
            'aboutUsImage4' => 'nullable|image|mimes:jpg,png,gif|max:2048',
            'homeBackGround' => 'nullable|image|mimes:jpg,png,gif|max:2048', // Validate homeBackGround if it's an image
            'homeText1' => 'nullable|string',
            'homeText2' => 'nullable|string', 
            'homeAboutImage' => 'nullable|image|mimes:jpg,png,gif|max:2048', // Validate homeAboutImage if it's an image
            'api_key'=>'nullable',
            'iframe_id'=>'nullable',
            'integration_id'=>'nullable',
            'paymob'=>'boolean',
            'number_whatsapp'=>'nullable',
            'number_phone'=>'nullable',
            'number_email'=>'nullable',
                        'homeAboutText'=>'nullable',


        ]);

    
        $settings = Setting::first(); // Fetch the current settings
    
        // Update text fields
        $settings->website_name = $validatedData['website_name'];
        $settings->website_description = $validatedData['website_description'];
        $settings->facebook = $validatedData['facebook'];
        $settings->twitter = $validatedData['twitter'];
        $settings->youtube = $validatedData['youtube'];
        $settings->instagram = $validatedData['instagram'];
        $settings->number_whatsapp = $validatedData['number_whatsapp'];
        $settings->number_phone = $validatedData['number_phone'];
        $settings->number_email = $validatedData['number_email'];
        $settings->homeAboutText = $validatedData['homeAboutText'];
        $settings->terms_and_conditions = $validatedData['terms_and_conditions'];


        // Update price and currency
        $settings->store_price = $validatedData['store_price'];
        $settings->currency = $validatedData['currency'];
        $settings->store_price = $validatedData['store_price'];
        $settings->currency = $validatedData['currency'];
        $settings->api_key = $validatedData['api_key'];
        $settings->iframe_id = $validatedData['iframe_id'];
        $settings->paymob = $validatedData['paymob'];
        $settings->integration_id = $validatedData['integration_id'];

    
        // Update aboutUsContent if provided
        $settings->aboutUsContent = $validatedData['aboutUsContent'] ?? $settings->aboutUsContent;
    
        // Update logo if uploaded
        if ($request->hasFile('logo')) {
            if ($settings->logo && file_exists(storage_path('app/public/' . $settings->logo))) {
                unlink(storage_path('app/public/' . $settings->logo));
            }
            $logoPath = $request->file('logo')->store('logos', 'public');
            $settings->logo = $logoPath;
        }
    
        // Update icon if uploaded
        if ($request->hasFile('icon')) {
            if ($settings->icon && file_exists(storage_path('app/public/' . $settings->icon))) {
                unlink(storage_path('app/public/' . $settings->icon));
            }
            $iconPath = $request->file('icon')->store('icons', 'public');
            $settings->icon = $iconPath;
        }
    
        // Update About Us images if uploaded
        
        
        // تأكد من حفظ الإعدادات بعد معالجة الصور
        
        
    
        // Update home-related fields if provided
        $settings->homeBackGround = $request->hasFile('homeBackGround') ? $request->file('homeBackGround')->store('home_backgrounds', 'public') : $settings->homeBackGround;
        $settings->homeText1 = $validatedData['homeText1'] ?? $settings->homeText1;
        $settings->homeText2 = $validatedData['homeText2'] ?? $settings->homeText2;
    
        // Update homeAboutImage if uploaded
        if ($request->hasFile('homeAboutImage')) {
            if ($settings->homeAboutImage && file_exists(storage_path('app/public/' . $settings->homeAboutImage))) {
                unlink(storage_path('app/public/' . $settings->homeAboutImage));
            }
            $homeAboutImagePath = $request->file('homeAboutImage')->store('home_about_images', 'public');
            $settings->homeAboutImage = $homeAboutImagePath;
        }

        if ($request->hasFile('aboutUsImage1')) {
            if ($settings->aboutUsImage1 && file_exists(storage_path('app/public/' . $settings->aboutUsImage1))) {
                unlink(storage_path('app/public/' . $settings->aboutUsImage1));
            }
            $homeAboutImagePath = $request->file('aboutUsImage1')->store('about_images', 'public');
            $settings->aboutUsImage1 = $homeAboutImagePath;
        }
        if ($request->hasFile('aboutUsImage2')) {
            if ($settings->aboutUsImage2 && file_exists(storage_path('app/public/' . $settings->aboutUsImage2))) {
                unlink(storage_path('app/public/' . $settings->aboutUsImage2));
            }
            $homeAboutImagePath = $request->file('aboutUsImage2')->store('about_images', 'public');
            $settings->aboutUsImage2 = $homeAboutImagePath;
        }
        if ($request->hasFile('aboutUsImage3')) {
            if ($settings->aboutUsImage3 && file_exists(storage_path('app/public/' . $settings->aboutUsImage3))) {
                unlink(storage_path('app/public/' . $settings->aboutUsImage3));
            }
            $homeAboutImagePath = $request->file('aboutUsImage3')->store('about_images', 'public');
            $settings->aboutUsImage3 = $homeAboutImagePath;
        }
        if ($request->hasFile('aboutUsImage4')) {
            if ($settings->aboutUsImage4 && file_exists(storage_path('app/public/' . $settings->aboutUsImage4))) {
                unlink(storage_path('app/public/' . $settings->aboutUsImage4));
            }
            $homeAboutImagePath = $request->file('aboutUsImage4')->store('about_images', 'public');
            $settings->aboutUsImage4 = $homeAboutImagePath;
        }

    
        $settings->save(); // Save the settings
    
        return redirect()->back()->with('success', 'Settings updated successfully!');
    }
    public function addCourse(Request $request)
    {
        try {
            // التحقق من البيانات المدخلة
            $data = $request->validate([
                'name' => 'required|string|max:255',
                'description' => 'nullable|string',
                'system' => 'required|in:American,British,Masry',
                'teacher_ids' => 'required|array',
                'teacher_ids.*' => 'exists:teachers,id',
                'course_img' => 'nullable|image|mimes:jpeg,png,jpg,gif|max:2048', // دعم رفع صورة
            ]);
    
            // رفع الصورة إذا تم رفعها
            $imagePath = null;
            if ($request->hasFile('course_img')) {
                $image = $request->file('course_img');
                $imageName = time() . '_' . $image->getClientOriginalName();
                $imagePath = $image->storeAs('courses', $imageName, 'public');
            }
    
            // إنشاء الكورس الجديد
            $course = Course::create([
                'name' => $data['name'],
                'description' => $data['description'],
                'system' => $data['system'],
                'course_img' => $imagePath, // تخزين مسار الصورة
            ]);
    
            // ربط المدرسين بالكورس
            $course->teachers()->attach($data['teacher_ids']);
    
            return redirect()->route('course.index')->with('success', 'Course created successfully.');
        } catch (\Exception $e) {
            return back()->withErrors(['error' => 'حدث خطأ أثناء إضافة الكورس: ' . $e->getMessage()]);
        }
    }
    


    public function updateCourse(Request $request, $id)
    {
        try {
            $course = Course::findOrFail($id);
    
            // التحقق من صحة البيانات
            $data = $request->validate([
                'name' => 'required|string|max:255',
                'description' => 'nullable|string',
                'system' => 'required|in:American,British,Masry',
                'teacher_ids' => 'required|array',
                'teacher_ids.*' => 'exists:teachers,id',
                'course_img' => 'nullable|image|mimes:jpeg,png,jpg,gif|max:2048',
            ]);
    
            // تحديث بيانات الكورس
            $course->update([
                'name' => $data['name'],
                'description' => $data['description'],
                'system' => $data['system'],
            ]);
    
            // تحديث الصورة إذا وُجدت
            if ($request->hasFile('course_img')) {
                if ($course->course_img && Storage::exists($course->course_img)) {
                    Storage::delete($course->course_img);
                }
                $imagePath = $request->file('course_img')->store('courses', 'public');
                $course->update(['course_img' => $imagePath]);
            }
    
            // تحديث المدرسين المرتبطين بالكورس
            $course->teachers()->sync($data['teacher_ids']);
    
            return redirect()->route('course.index')->with('success', 'Course updated successfully.');
        } catch (\Exception $e) {
            return back()->withErrors(['error' => 'حدث خطأ أثناء تحديث الكورس: ' . $e->getMessage()]);
        }
    }
    

    public function deleteCourse($id)
    {
        try {
            // العثور على الكورس
            $course = Course::findOrFail($id);

            // حذف الكورس مع إزالة كل المدرسين المرتبطين
            $course->teachers()->detach(); // إزالة العلاقات قبل حذف الكورس
            $course->delete(); // حذف الكورس

            return redirect()->back()->with('success', 'Course deleted successfully.');
        } catch (\Exception $e) {
            // إذا حدث خطأ، يتم طباعة رسالة الخطأ
            return back()->withErrors(['error' => 'حدث خطأ أثناء حذف الكورس: ' . $e->getMessage()]);
        }
    }




    /**
     * Remove the specified resource from storage.
     */
    public function destroy(string $id)
    {
        //
    }
}
