<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Course extends Model
{
    use HasFactory;

    protected $fillable = [
        'name', 
        'description', 
        'system',
        'course_img'
    ];

    // Define the many-to-many relationship with Teacher
    public function teachers()
    {
        return $this->belongsToMany(Teacher::class, 'course_teacher');
    }

    // Enrollments relation
    public function enrollments()
    {
        return $this->hasMany(Enrollment::class);
    }
    public function lectures()
    {
        return $this->hasMany(Lecture::class);
    }
}
