<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Lecture extends Model
{
    use HasFactory;

    // Define the table associated with the model (optional if table name matches plural of model name)
    protected $table = 'lectures';

    // Define the fillable fields
    protected $fillable = [
        'course_id', 
        'teacher_id', 
        'title', 
        'description', 
        'start_time', 
        'duration',
        'lecture_img',
        'price',
        'what_learn',
        'lecture_video',
        'lecture_zoom'
    ];

    // Define the relationships
    public function course()
    {
        return $this->belongsTo(Course::class);
    }

    public function teacher()
    {
        return $this->belongsTo(Teacher::class, 'teacher_id');
    }
    public function enrollments()
{
    return $this->hasMany(Enrollment::class);
}
// Lecture.php
public function students()
{
    return $this->belongsToMany(Student::class, 'enrollments', 'lecture_id', 'student_id');
}


}
