<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Teacher extends Model
{

    protected $table = 'teachers';

    protected $fillable = [
        'user_id',   // Foreign key to User model
        'name',
        'subject',
        'profile_photo',
        'price_per_session',
        'balance'
    ];

    public function user()
    {
        return $this->belongsTo(User::class);
    }
    public function courses()
    {
        return $this->belongsToMany(Course::class, 'course_teacher');
    }
}
