<?php

namespace App\Models;

use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    protected $fillable = [
        'name',
        'email',
        'password',
        'role', // 'student', 'teacher', or 'admin'
    ];

    protected $hidden = [
        'password',
        'remember_token',
    ];

    public function isStudent()
    {
        return $this->role === 'student';
    }

    public function isTeacher()
    {
        return $this->role === 'teacher';
    }

    public function isAdmin()
    {
        return $this->role === 'admin';
    }
    public function student()
{
    return $this->hasOne(Student::class);
}
    public function teacher()
    {
        return $this->hasOne(Teacher::class);
    }
    public function enrollments()
{
    return $this->hasMany(Enrollment::class);
}

}
